/**
 * Zaměstnanec, který je placen pouze provizí z prodaného zboží.
 */
public class CommissionEmployee3 {

	/**
	 * Křestní jméno.
	 */
	private String firstName;

	/**
	 * Příjmení.
	 */
	private String lastName;

	/**
	 * Číslo sociálního pojištění.
	 */
	private String socialSecurityNumber;

	/**
	 * Týdenní hrubý prodej.
	 */
	private double grossSales;

	/**
	 * Podíl provize.
	 */
	private double commissionRate;

	/**
	 * Vytvoří novou instanci třídy CommissionEmployee3.
	 * 
	 * @param first
	 *            křestní jméno zaměstnance.
	 * @param last
	 *            příjmení zaměstnance.
	 * @param ssn
	 *            číslo sociálního pojištění zaměstnance.
	 * @param sales
	 *            týdenní hrubý prodej zaměstnance.
	 * @param rate
	 *            podíl provize zaměstnance.
	 */
	public CommissionEmployee3(String first, String last,
			String ssn, double sales, double rate) {
		// zde dojde k implicitnímu zavolání konstruktoru třídy
		// Object
		setFirstName(first);
		setLastName(last);
		setSocialSecurityNumber(ssn);
		setGrossSales(sales);
		setCommissionRate(rate);
	}

	/**
	 * Nastaví křestní jméno zaměstnance.
	 * 
	 * @param first
	 *            nastavované křestní jméno zaměstnance.
	 */
	public void setFirstName(String first) {
		firstName = first;
	}

	/**
	 * Vrátí křestní jméno zaměstnance.
	 * 
	 * @return křestní jméno zaměstnance.
	 */
	public String getFirstName() {
		return firstName;
	}

	/**
	 * Nastaví příjmení zaměstnance.
	 * 
	 * @param last
	 *            nastavované příjmení zaměstnance.
	 */
	public void setLastName(String last) {
		lastName = last;
	}

	/**
	 * Vrátí příjmení zaměstnance.
	 * 
	 * @return příjmení zaměstnance.
	 */
	public String getLastName() {
		return lastName;
	}

	/**
	 * Nastaví číslo sociálního pojištění zaměstnance.
	 * 
	 * @param ssn
	 *            nastavované číslo sociálního pojištění zaměstnance.
	 */
	public void setSocialSecurityNumber(String ssn) {
		// mělo by se ověřit
		socialSecurityNumber = ssn;
	}

	/**
	 * Vrátí číslo sociálního pojištění zaměstnance.
	 * 
	 * @return číslo sociálního pojištění zaměstnance.
	 */
	public String getSocialSecurityNumber() {
		return socialSecurityNumber;
	}

	/**
	 * Nastaví týdenní hrubý prodej zaměstnance.
	 * 
	 * @param sales
	 *            nastavovaný týdenní hrubý prodej zaměstnance.
	 */
	public void setGrossSales(double sales) {
		grossSales = (sales < 0.0) ? 0.0 : sales;
	}

	/**
	 * Vrátí týdenní hrubý prodej zaměstnance.
	 * 
	 * @return týdenní hrubý prodej zaměstnance.
	 */
	public double getGrossSales() {
		return grossSales;
	}

	/**
	 * Nastaví podíl provize zaměstnance.
	 * 
	 * @param rate
	 *            nastavovaný podíl provize zaměstnance.
	 */
	public void setCommissionRate(double rate) {
		commissionRate = (rate > 0.0 && rate < 1.0) ? rate : 0.0;
	}

	/**
	 * Vrátí podíl provize zaměstnance.
	 * 
	 * @return podíl provize zaměstnance.
	 */
	public double getCommissionRate() {
		return commissionRate;
	}

	/**
	 * Vrátí týdenní výdělek zaměstnance.
	 * 
	 * @return týdenní výdělek zaměstnance.
	 */
	public double earnings() {
		return getCommissionRate() * getGrossSales();
	}

	@Override
	public String toString() {
		return String.format(
				"%s: %s %s\n%s: %s\n%s: %.2f\n%s: %.2f",
				"komisní zaměstnanec", getFirstName(),
				getLastName(), "číslo sociálního pojištění",
				getSocialSecurityNumber(), "celkový prodej",
				getGrossSales(), "podíl provize",
				getCommissionRate());
	}
}